/*	
	Jeff Braun (March 2001)
	email1: yobkadon@hotmail.com
	email2: brauns@und-alum.org
*/

/***************************************************************
include header files
***************************************************************/
//#define DEBUG 1

#include <Application.h>
#include <Button.h>
#include <CheckBox.h>
#include <Debug.h>
#include <MessageRunner.h>
#include <ScrollView.h>
#include <Window.h>
#include <View.h>

#include "TestListItem.h"
#include "FastListView.h"
#include "Sample.h"

/***************************************************************
***************************************************************/
int
main
	(
	int
,	char **
	)
{
	PRINT (("main\n"));
	new CApp;
	be_app->Run ();
	delete be_app;

	return (0);
}


/***************************************************************
***************************************************************/
CApp :: CApp
	(
	void
	)
:	BApplication ("application/x-vnd.JeffBraun-FastFIFO")
{
	PRINT (("CApp::CApp\n"));
	new CWindow (BRect (50, 50, 500, 200));
}


/***************************************************************
***************************************************************/
void
CApp :: MessageReceived
	(
	BMessage * msg
	)
{
	BApplication::MessageReceived (msg);
}


/***************************************************************
***************************************************************/
CWindow :: CWindow
	(
	BRect frame
	)
:	BWindow (frame, "The FastFIFO Sample App", B_DOCUMENT_WINDOW, B_ASYNCHRONOUS_CONTROLS)
{
	PRINT (("CWindow::CWindow\n"));
	BRect rc (Bounds ());
	CView * pCV (new CView (rc));
	AddChild (pCV);

	Show ();
}


/***************************************************************
***************************************************************/
void
CWindow :: MessageReceived
	(
	BMessage * msg
	)
{
	BWindow::MessageReceived (msg);
}


bool CWindow :: QuitRequested
	(
	void
	)
{
	be_app->PostMessage (B_QUIT_REQUESTED);
	return true;
}


/***************************************************************
***************************************************************/
CView :: CView
	(
	BRect frame
	)
:	BView (frame, "The View", B_FOLLOW_ALL_SIDES, B_PULSE_NEEDED)
,	m_button1 (NULL)
,	m_button2 (NULL)
,	m_box (NULL)
,	m_FLV (NULL)
,	m_runner (NULL)
{
	PRINT (("CView::CView\n"));
	SetViewColor (255, 128, 128, 255);

	frame.left += 10.0f;
	frame.top += 50.0f;
	frame.right -= 40.0f;
	frame.bottom -= 40.0f;
	PRINT (("  create new FLV\n"));
	m_FLV = new FastListView<TestListItem> (frame, "a FastListView", 35, B_FOLLOW_ALL_SIDES, B_NAVIGABLE | B_WILL_DRAW | B_FRAME_EVENTS);
	PRINT (("  add FLV to ScrollView\n"));
	BRect ViewFrame (m_FLV->Frame());
	BRect LabelsFrame (ViewFrame);
	LabelsFrame.bottom = 20.0f;
	BScrollView *pBSV (new BScrollView("scroll_view", m_FLV, B_FOLLOW_ALL_SIDES, 0, true, true, B_FANCY_BORDER));
	AddChild (pBSV);
	pBSV->SetViewColor (0,0,255,255);
	PRINT (("  added.\n"));

//	BRect NewFrame (m_FLV->Frame());

//	m_FLV->ResizeTo (ViewFrame.right-ViewFrame.left, NewFrame.bottom - 20.0f - 1.0f);
//	m_FLV->MoveTo (NewFrame.left, NewFrame.top + (20.0f - 1.0f));
	//Resize the m_FLV view to make room for the column headers
	//m_FLV->ResizeTo (ViewFrame.right - ViewFrame.left, ViewFrame.bottom - LabelsFrame.bottom - 1.0);
	//m_FLV->MoveTo (NewFrame.left, NewFrame.top + (LabelsFrame.bottom - LabelsFrame.top + 1.0));

	m_button1 = new BButton (BRect (10, 10, 0, 0), "101", "Add an entry", new BMessage ('adde'), B_FOLLOW_LEFT | B_FOLLOW_TOP);
	m_button1->ResizeToPreferred ();
	AddChild (m_button1);

	BRect bnds (m_button1->Frame ());
	m_button2 = new BButton (BRect (bnds.right + 20, 10, 0, 0), "102", "ScrollToSelection", new BMessage ('scts'), B_FOLLOW_LEFT | B_FOLLOW_TOP);
	m_button2->ResizeToPreferred ();
	AddChild (m_button2);
	
	bnds = m_button2->Frame ();
	m_box = new BCheckBox (BRect (bnds.right + 20,10,200,100), "timer", "timer", new BMessage ('timr'));
	m_box->ResizeToPreferred ();
	AddChild (m_box);
}


/***************************************************************
***************************************************************/
void
CView :: AllAttached
	(
	void
	)
{
	m_button1->SetTarget (this);
	m_button1->MakeFocus (true);
	m_button2->SetTarget (this);
	m_box->SetTarget (this);
}


/***************************************************************
***************************************************************/
void
CView :: MessageReceived
	(
	BMessage * msg
	)
{
	switch (msg->what)
	{
		case 'adde':
			{
			m_FLV->DisableForAdd (true);
			TestListItem * pTLI (NULL);
			for (int i (0); i < 1; i++)
			{
				pTLI = new TestListItem ();
				m_FLV->AddItem (pTLI);
			}
			m_FLV->DisableForAdd (false);
			}
			break;
		case 'scts':
			m_FLV->ScrollToSelection ();
			break;
		case 'timr':
			if (m_runner)
			{
				delete m_runner;
				m_runner = NULL;
			}
			else
			{
				BMessage msg ('auto');
				m_runner = new BMessageRunner (BMessenger (this), &msg, 50000);
			}
			break;
		case 'auto':
			{
			m_FLV->DisableForAdd (true);
			TestListItem * pTLI (NULL);
			for (int i (0); i < 5; i++)
			{
				pTLI = new TestListItem ();
				m_FLV->AddItem (pTLI);
			}
			m_FLV->DisableForAdd (false);
			}
			break;
		default:
			BView::MessageReceived (msg);
			break;
	}
}


/***************************************************************
***************************************************************/
void CView :: MouseMoved
	(
	BPoint point
,	uint32 transit
,	const BMessage * drag
	)
{
	BView::MouseMoved (point, transit, drag);
}


/***************************************************************
have to use SetPulseRate in BWindow constructor before this will work.
***************************************************************/
void CView :: Pulse
	(
	void
	)
{
	BView::Pulse ();
}
