/*	
	Jeff Braun (March 2001)
	email1: yobkadon@hotmail.com
	email2: brauns@und-alum.org
*/

#include <Point.h>
#include <Rect.h>
#include <View.h>
#include <stdio.h>
#include "TestListItem.h"

const int size = 160;
const char * pString = 	"This is some nice text for us to draw - ";

uint64 TestListItem::m_count = 0;

TestListItem :: TestListItem ()
:	m_pchar (NULL)
,	fWidth (0.0f)
,	fHeight (0.0f)
,	fSelected (false)
,	fEnabled (true)
{
	m_pchar = new char[size];
	sprintf (m_pchar, "%s%Li", pString, m_count++);
}

TestListItem :: ~TestListItem (void)
{
	if (m_pchar)
	{
		delete [] m_pchar;
		m_pchar = NULL;
	}
}

float TestListItem :: Height (void) const
{
	return fHeight;
}

float
TestListItem :: Width (void) const
{
	return fWidth;
}

bool
TestListItem :: IsSelected (void) const
{
	return fSelected;
}

void
TestListItem :: Select (void)
{
	fSelected = true;
}

void
TestListItem :: Deselect (void)
{
	fSelected = false;
}

void
TestListItem :: SetEnabled (bool on)
{
}

bool
TestListItem :: IsEnabled (void) const
{
	return fEnabled;
}

void
TestListItem :: SetHeight (float height)
{
}

void
TestListItem :: SetWidth (float width)
{
}

//TestListItem :: DrawItem (BView *owner, BRect bounds, bool complete)
void
TestListItem :: DrawItem (BView *owner, BRect bounds, BRect * pBoundingBox, int32 boxcount, bool complete)
{
	rgb_color backcolor;
	//rgb_color textcolor;
	//textcolor.red = 0; textcolor.green = 0; textcolor.blue = 0; textcolor.alpha = 255;

	if (fSelected)
	{
		backcolor.red = 192; backcolor.green = 192; backcolor.blue = 192; backcolor.alpha = 255;
	}
	else
	{
		backcolor.red = 255; backcolor.green = 255; backcolor.blue = 255; backcolor.alpha = 255;
	}

	owner->SetDrawingMode (B_OP_COPY);
	owner->SetLowColor (backcolor);
	if (fSelected || complete)
	{
		owner->SetHighColor (backcolor);
		owner->FillRect (bounds);
	}
	
	while (boxcount-- > 0)
	{
		switch (boxcount)
		{
			case 0:
				owner->SetHighColor (0,0,0,255);
				owner->DrawString ("Method", BPoint (bounds.left, bounds.top + 13.0f));
				break;
			case 1:
				owner->SetHighColor (0,0,0,255);
				owner->DrawString ("Class", BPoint (bounds.left + 50.0f, bounds.top + 13.0f));
				break;
			case 2:
				owner->SetHighColor (0,0,0,255);
				owner->DrawString ("File", BPoint (bounds.left + 100.0f, bounds.top + 13.0f));
				break;
			case 3:
				owner->SetHighColor (0,0,0,255);
				owner->DrawString ("Line", BPoint (bounds.left + 150.0f, bounds.top + 13.0f));
				break;
			case 4:
				owner->SetHighColor (0,0,0,255);
				owner->DrawString ("ThreadID", BPoint (bounds.left + 200.0f, bounds.top + 13.0f));
				break;
			case 5:
				owner->SetHighColor (0,0,0,255);
				owner->DrawString ("Sequence", BPoint (bounds.left + 250.0f, bounds.top + 13.0f));
				break;
			case 6:
				owner->SetHighColor (0,0,0,255);
				owner->DrawString ("Date", BPoint (bounds.left + 300.0f, bounds.top + 13.0f));
				break;
			case 7:
				owner->SetHighColor (0,0,0,255);
				owner->DrawString ("Time", BPoint (bounds.left + 350.0f, bounds.top + 13.0f));
				break;
			case 8:
				owner->SetHighColor (0,0,0,255);
				owner->DrawString (m_pchar, BPoint (bounds.left + 400.0f, bounds.top + 13.0f));
				break;
			default:
				break;
		}
	}

	pattern stripes = { 0xc7, 0x8f, 0x1f, 0x3e, 0x7c, 0xf8, 0xf1, 0xe3 };

	owner->SetHighColor (0,255,0,255);
	owner->StrokeLine (BPoint (bounds.left, bounds.top), BPoint (bounds.right, bounds.top), stripes);

	owner->SetHighColor (225,0,0,255);
	owner->StrokeLine (BPoint (bounds.left,bounds.bottom), BPoint (bounds.right, bounds.bottom), stripes);
}

